clear all
set(0,'defaultTextFontName','Times');
%% Loading irradiation data

file=load('globirr2.txt');
time = file(:,1);
irr = file(:,2);        % irradiation for Pozo Colorado in kW/m2

%% Creating load vectors

len=length(irr);
irradj=linspace(1,1,len);
diff1=linspace(1,1,len);
diff2=linspace(1,1,len);
totalkwh=linspace(1,1,len/24);
Lcase1=linspace(1,1,len);
Lcase2=linspace(1,1,len);
Lcase3=linspace(1,1,len);
Lcase4=linspace(1,1,len);
Lcase5=linspace(1,1,len);
Lcase6=linspace(1,1,len);

irradj=irr*0.15*791/1000;



%% Creating load profiles

for i = 1:len                   % Load profile Case 1, Case 2, Case 3, Case 4
    if mod(i,24) >= 9 && mod(i,24) <= 17    % Between 8am and 5pm
        Lcase1(i)=65.6;
        Lcase2(i)=35.8;
        Lcase4(i) = 42.16;
    else                                    % Between 5pm and 8am 
        Lcase1(i)=0;
        Lcase2(i)=17.9;
        Lcase4(i) = 14.06;
    end
    Lcase3(i)=24.6;
end

for i = 1:len
    if mod(i,24) >= 9 && mod(i,24) <= 10 | mod(i,24) >= 16 && mod(i,24) <= 17 ;  % Load profile Case 5 and Case 6
        Lcase5(i) = 27.46;
        Lcase6(i) = 42.18;
    elseif mod(i,24) >= 10 && mod(i,24) <= 15;
        Lcase5(i) = 54.92;
        Lcase6(i) = 84.34;
    else
        mod(i,24) >= 18 && mod(i,24) <= 8;
        Lcase5(i) = 13.74;
        Lcase6(i) = 0;
    end
end
   

%% Finding energy deficit

for i=1:len                 % Finding deficit Case 1-5
diff1 (i) = irradj(i)-Lcase1(i);
diff2 (i) = irradj(i)-Lcase2(i);
diff3 (i) = irradj(i)-Lcase3(i);
diff4 (i) = irradj(i)-Lcase4(i);
diff5 (i) = irradj(i)-Lcase5(i);
diff6 (i) = irradj(i)-Lcase6(i);

if diff1(i)<0
    hourdeficit1(i)=-diff1(i);   % Deficit in kWh Case 1, positive
else
    hourdeficit1(i)=0;
end
if diff2(i)<0
    hourdeficit2(i)=-diff2(i);   % Deficit in kWh Case 2, positive
    else
    hourdeficit2(i)=0;
end
if diff3(i)<0
    hourdeficit3(i)=-diff3(i);   % Deficit in kWh Case 3, positive
    else
    hourdeficit3(i)=0;
end
if diff4(i)<0
    hourdeficit4(i)=-diff4(i);   % Deficit in kWh Case 4, positive
    else
    hourdeficit4(i)=0;
end
if diff5(i)<0
    hourdeficit5(i)=-diff5(i);   % Deficit in kWh Case 5, positive
    else
    hourdeficit5(i)=0;
end
if diff6(i)<0
    hourdeficit6(i)=-diff6(i);   % Deficit in kWh Case 6, positive
    else
    hourdeficit6(i)=0;
end

if diff1(i)>0
    hoursurplus1(i) = diff1(i);   % Surplus in kWh Case 1, positive
else
    hoursurplus1(i) = 0;
end
if diff2(i)>0
    hoursurplus2(i) = diff2(i);   % Surplus in kWh Case 2, positive
    else
    hoursurplus2(i) = 0;
end
if diff3(i)>0
    hoursurplus3(i) = diff3(i);   % Surplus in kWh Case 3, positive
    else
    hoursurplus3(i) = 0;
end
if diff4(i)>0
    hoursurplus4(i) = diff4(i);   % Surplus in kWh Case 4, positive
    else
    hoursurplus4(i) = 0;
end
if diff5(i)>0
    hoursurplus5(i) = diff5(i);   % Surplus in kWh Case 5, positive
    else
    hoursurplus5(i) = 0;
end
if diff6(i)>0
    hoursurplus6(i) = diff6(i);   % Surplus in kWh Case 6, positive
    else
    hoursurplus6(i)=0;
end
end



j=1;
temp1 = 0;temp2 = 0;temp3 = 0;temp4 = 0;temp5 = 0;temp6 = 0;
temp1x = 0; temp2x = 0; temp3x = 0; temp4x = 0; temp5x = 0; temp6x = 0;

for i =1:len          % Finding the daily deficit 
    if mod(i,24)==0
        temp1 = temp1+hourdeficit1(i); % for hour nr 24   
        temp2 = temp2+hourdeficit2(i);
        temp3 = temp3+hourdeficit3(i);
        temp4 = temp4 + hourdeficit4(i);
        temp5 = temp5 + hourdeficit5(i);
        temp6 = temp6 + hourdeficit6(i);
        temp1x = temp1x + hoursurplus1(i);
        temp2x = temp2x + hoursurplus2(i);
        temp3x = temp3x + hoursurplus3(i);
        temp4x = temp4x + hoursurplus4(i);
        temp5x = temp5x + hoursurplus5(i);
        temp5x = temp5x + hoursurplus5(i);
        daydeficit1(j)= temp1;     % saving the sum in daydeficit
        daydeficit2(j)= temp2;
        daydeficit3(j) = temp3;
        daydeficit4(j) = temp4;
        daydeficit5(j) = temp5;
        daydeficit6(j) = temp6;
        daysurplus1(j) = temp1x;
        daysurplus2(j) = temp2x;
        daysurplus3(j) = temp3x;
        daysurplus4 (j) = temp4x;
        daysurplus5 (j) = temp5x;
        daysurplus6 (j) = temp6x;
        temp1 = 0;temp2 = 0;temp3 = 0; temp4 = 0;temp5 = 0;temp6 = 0;
        temp1x = 0;temp2x = 0;temp3x = 0; temp4x = 0;temp5x = 0;temp6x = 0;
        j=j+1;
    else
        temp1 = temp1+hourdeficit1(i);    % summing for every hour except for hour nr 24
        temp2 = temp2+hourdeficit2(i);
        temp3 = temp3+hourdeficit3(i);
        temp4 = temp4+hourdeficit4(i);
        temp5 = temp5+hourdeficit5(i);
        temp6 = temp6+hourdeficit6(i);
        temp1x = temp1x+hoursurplus1(i);    % summing for every hour except for hour nr 24
        temp2x = temp2x+hoursurplus2(i);
        temp3x = temp3x+hoursurplus3(i);
        temp4x = temp4x+hoursurplus4(i);
        temp5x = temp5x+hoursurplus5(i);
        temp6x = temp6x+hoursurplus6(i);
    end
end

monthsurplus1 = linspace(0,0,12); monthdeficit1 = linspace(0,0,12);
monthsurplus2 = linspace(0,0,12); monthdeficit2 = linspace(0,0,12);
monthsurplus3 = linspace(0,0,12); monthdeficit3 = linspace(0,0,12);
monthsurplus4 = linspace(0,0,12); monthdeficit4 = linspace(0,0,12);
monthsurplus5 = linspace(0,0,12); monthdeficit5 = linspace(0,0,12);
monthsurplus6 = linspace(0,0,12); monthdeficit6 = linspace(0,0,12);

for i = 1:31                              % Creating monthly surplus vector for every case
    monthsurplus1(1) = monthsurplus1(1) + daysurplus1(i); monthdeficit1(1) = monthdeficit1(1) + daydeficit1(i);
    monthsurplus2(1) = monthsurplus2(1) + daysurplus2(i); monthdeficit2(1) = monthdeficit2(1) + daydeficit2(i);
    monthsurplus3(1) = monthsurplus3(1) + daysurplus3(i); monthdeficit3(1) = monthdeficit3(1) + daydeficit3(i);
    monthsurplus4(1) = monthsurplus4(1) + daysurplus4(i); monthdeficit4(1) = monthdeficit4(1) + daydeficit4(i);
    monthsurplus5(1) = monthsurplus5(1) + daysurplus5(i); monthdeficit5(1) = monthdeficit5(1) + daydeficit5(i);
    monthsurplus6(1) = monthsurplus6(1) + daysurplus6(i); monthdeficit6(1) = monthdeficit6(1) + daydeficit6(i);
end
for i = 32:59
    monthsurplus1(2) = monthsurplus1(2) + daysurplus1(i); monthdeficit1(2) = monthdeficit1(2) + daydeficit1(i);
    monthsurplus2(2) = monthsurplus2(2) + daysurplus2(i); monthdeficit2(2) = monthdeficit2(2) + daydeficit2(i);
    monthsurplus3(2) = monthsurplus3(2) + daysurplus3(i); monthdeficit3(2) = monthdeficit3(2) + daydeficit3(i);
    monthsurplus4(2) = monthsurplus4(2) + daysurplus4(i); monthdeficit4(2) = monthdeficit4(2) + daydeficit4(i);
    monthsurplus5(2) = monthsurplus5(2) + daysurplus5(i); monthdeficit5(2) = monthdeficit5(2) + daydeficit5(i);
    monthsurplus6(2) = monthsurplus6(2) + daysurplus6(i); monthdeficit6(2) = monthdeficit6(2) + daydeficit6(i);
end
for i = 60:90
    monthsurplus1(3) = monthsurplus1(3) + daysurplus1(i); monthdeficit1(3) = monthdeficit1(3) + daydeficit1(i);
    monthsurplus2(3) = monthsurplus2(3) + daysurplus2(i); monthdeficit2(3) = monthdeficit2(3) + daydeficit2(i);
    monthsurplus3(3) = monthsurplus3(3) + daysurplus3(i); monthdeficit3(3) = monthdeficit3(3) + daydeficit3(i);
    monthsurplus4(3) = monthsurplus4(3) + daysurplus4(i); monthdeficit4(3) = monthdeficit4(3) + daydeficit4(i);
    monthsurplus5(3) = monthsurplus5(3) + daysurplus5(i); monthdeficit5(3) = monthdeficit5(3) + daydeficit5(i);
    monthsurplus6(3) = monthsurplus6(3) + daysurplus6(i); monthdeficit6(3) = monthdeficit6(3) + daydeficit6(i);
end
for i = 91:120
    monthsurplus1(4) = monthsurplus1(4) + daysurplus1(i); monthdeficit1(4) = monthdeficit1(4) + daydeficit1(i);
    monthsurplus2(4) = monthsurplus2(4) + daysurplus2(i); monthdeficit2(4) = monthdeficit2(4) + daydeficit2(i);
    monthsurplus3(4) = monthsurplus3(4) + daysurplus3(i); monthdeficit3(4) = monthdeficit3(4) + daydeficit3(i);
    monthsurplus4(4) = monthsurplus4(4) + daysurplus4(i); monthdeficit4(4) = monthdeficit4(4) + daydeficit4(i);
    monthsurplus5(4) = monthsurplus5(4) + daysurplus5(i); monthdeficit5(4) = monthdeficit5(4) + daydeficit5(i);
    monthsurplus6(4) = monthsurplus6(4) + daysurplus6(i); monthdeficit6(4) = monthdeficit6(4) + daydeficit6(i);
end
for i = 121:151
    monthsurplus1(5) = monthsurplus1(5) + daysurplus1(i); monthdeficit1(5) = monthdeficit1(5) + daydeficit1(i);
    monthsurplus2(5) = monthsurplus2(5) + daysurplus2(i); monthdeficit2(5) = monthdeficit2(5) + daydeficit2(i);
    monthsurplus3(5) = monthsurplus3(5) + daysurplus3(i); monthdeficit3(5) = monthdeficit3(5) + daydeficit3(i);
    monthsurplus4(5) = monthsurplus4(5) + daysurplus4(i); monthdeficit4(5) = monthdeficit4(5) + daydeficit4(i);
    monthsurplus5(5) = monthsurplus5(5) + daysurplus5(i); monthdeficit5(5) = monthdeficit5(5) + daydeficit5(i);
    monthsurplus6(5) = monthsurplus6(5) + daysurplus6(i); monthdeficit6(5) = monthdeficit6(5) + daydeficit6(i);
end
for i = 152:181
    monthsurplus1(6) = monthsurplus1(6) + daysurplus1(i); monthdeficit1(6) = monthdeficit1(6) + daydeficit1(i);
    monthsurplus2(6) = monthsurplus2(6) + daysurplus2(i); monthdeficit2(6) = monthdeficit2(6) + daydeficit2(i);
    monthsurplus3(6) = monthsurplus3(6) + daysurplus3(i); monthdeficit3(6) = monthdeficit3(6) + daydeficit3(i);
    monthsurplus4(6) = monthsurplus4(6) + daysurplus4(i); monthdeficit4(6) = monthdeficit4(6) + daydeficit4(i);
    monthsurplus5(6) = monthsurplus5(6) + daysurplus5(i); monthdeficit5(6) = monthdeficit5(6) + daydeficit5(i);
    monthsurplus6(6) = monthsurplus6(6) + daysurplus6(i); monthdeficit6(6) = monthdeficit6(6) + daydeficit6(i);
end
for i = 182:212
    monthsurplus1(7) = monthsurplus1(7) + daysurplus1(i); monthdeficit1(7) = monthdeficit1(7) + daydeficit1(i);
    monthsurplus2(7) = monthsurplus2(7) + daysurplus2(i); monthdeficit2(7) = monthdeficit2(7) + daydeficit2(i);
    monthsurplus3(7) = monthsurplus3(7) + daysurplus3(i); monthdeficit3(7) = monthdeficit3(7) + daydeficit3(i);
    monthsurplus4(7) = monthsurplus4(7) + daysurplus4(i); monthdeficit4(7) = monthdeficit4(7) + daydeficit4(i);
    monthsurplus5(7) = monthsurplus5(7) + daysurplus5(i); monthdeficit5(7) = monthdeficit5(7) + daydeficit5(i);
    monthsurplus6(7) = monthsurplus6(7) + daysurplus6(i); monthdeficit6(7) = monthdeficit6(7) + daydeficit6(i);
end
for i = 213:243
    monthsurplus1(8) = monthsurplus1(8) + daysurplus1(i); monthdeficit1(8) = monthdeficit1(8) + daydeficit1(i);
    monthsurplus2(8) = monthsurplus2(8) + daysurplus2(i); monthdeficit2(8) = monthdeficit2(8) + daydeficit2(i);
    monthsurplus3(8) = monthsurplus3(8) + daysurplus3(i); monthdeficit3(8) = monthdeficit3(8) + daydeficit3(i);
    monthsurplus4(8) = monthsurplus4(8) + daysurplus4(i); monthdeficit4(8) = monthdeficit4(8) + daydeficit4(i);
    monthsurplus5(8) = monthsurplus5(8) + daysurplus5(i); monthdeficit5(8) = monthdeficit5(8) + daydeficit5(i);
    monthsurplus6(8) = monthsurplus6(8) + daysurplus6(i); monthdeficit6(8) = monthdeficit6(8) + daydeficit6(i);
end
for i = 244:273
    monthsurplus1(9) = monthsurplus1(9) + daysurplus1(i); monthdeficit1(9) = monthdeficit1(9) + daydeficit1(i);
    monthsurplus2(9) = monthsurplus2(9) + daysurplus2(i); monthdeficit2(9) = monthdeficit2(9) + daydeficit2(i);
    monthsurplus3(9) = monthsurplus3(9) + daysurplus3(i); monthdeficit3(9) = monthdeficit3(9) + daydeficit3(i);
    monthsurplus4(9) = monthsurplus4(9) + daysurplus4(i); monthdeficit4(9) = monthdeficit4(9) + daydeficit4(i);
    monthsurplus5(9) = monthsurplus5(9) + daysurplus5(i); monthdeficit5(9) = monthdeficit5(9) + daydeficit5(i);
    monthsurplus6(9) = monthsurplus6(9) + daysurplus6(i); monthdeficit6(9) = monthdeficit6(9) + daydeficit6(i);
end
for i = 274:304
    monthsurplus1(10) = monthsurplus1(10) + daysurplus1(i); monthdeficit1(10) = monthdeficit1(10) + daydeficit1(i);
    monthsurplus2(10) = monthsurplus2(10) + daysurplus2(i); monthdeficit2(10) = monthdeficit2(10) + daydeficit2(i);
    monthsurplus3(10) = monthsurplus3(10) + daysurplus3(i); monthdeficit3(10) = monthdeficit3(10) + daydeficit3(i);
    monthsurplus4(10) = monthsurplus4(10) + daysurplus4(i); monthdeficit4(10) = monthdeficit4(10) + daydeficit4(i);
    monthsurplus5(10) = monthsurplus5(10) + daysurplus5(i); monthdeficit5(10) = monthdeficit5(10) + daydeficit5(i);
    monthsurplus6(10) = monthsurplus6(10) + daysurplus6(i); monthdeficit6(10) = monthdeficit6(10) + daydeficit6(i);
end
for i = 305:334
    monthsurplus1(11) = monthsurplus1(11) + daysurplus1(i); monthdeficit1(11) = monthdeficit1(11) + daydeficit1(i);
    monthsurplus2(11) = monthsurplus2(11) + daysurplus2(i); monthdeficit2(11) = monthdeficit2(11) + daydeficit2(i);
    monthsurplus3(11) = monthsurplus3(11) + daysurplus3(i); monthdeficit3(11) = monthdeficit3(11) + daydeficit3(i);
    monthsurplus4(11) = monthsurplus4(11) + daysurplus4(i); monthdeficit4(11) = monthdeficit4(11) + daydeficit4(i);
    monthsurplus5(11) = monthsurplus5(11) + daysurplus5(i); monthdeficit5(11) = monthdeficit5(11) + daydeficit5(i);
    monthsurplus6(11) = monthsurplus6(11) + daysurplus6(i); monthdeficit6(11) = monthdeficit6(11) + daydeficit6(i);
end
for i = 335:365
    monthsurplus1(12) = monthsurplus1(12) + daysurplus1(i); monthdeficit1(12) = monthdeficit1(12) + daydeficit1(i);
    monthsurplus2(12) = monthsurplus2(12) + daysurplus2(i); monthdeficit2(12) = monthdeficit2(12) + daydeficit2(i);
    monthsurplus3(12) = monthsurplus3(12) + daysurplus3(i); monthdeficit3(12) = monthdeficit3(12) + daydeficit3(i);
    monthsurplus4(12) = monthsurplus4(12) + daysurplus4(i); monthdeficit4(12) = monthdeficit4(12) + daydeficit4(i);
    monthsurplus5(12) = monthsurplus5(12) + daysurplus5(i); monthdeficit5(12) = monthdeficit5(12) + daydeficit5(i);
    monthsurplus6(12) = monthsurplus6(12) + daysurplus6(i); monthdeficit6(12) = monthdeficit6(12) + daydeficit6(i);
end


figure (1)
plot(daydeficit1,'LineWidth',1.2);
hold on
plot(daydeficit2,'r','LineWidth',1.2);
hold on
plot(daydeficit3,'g','LineWidth',1.2);
hold on
plot(daydeficit4,'c','LineWidth',1.2);
hold on
plot(daydeficit5,'k','LineWidth',1.2);
hold on
plot(daydeficit6,'m','LineWidth',1.2);
hold on
set(gca,'FontSize',12,'fontname','times');
xlabel('Days');
ylabel('Energy deficit (kWh)');
legend('Scenario 1','Scenario 2','Scenario 3','Scenario 4', 'Scenario 5', 'Scenario 6');
axis([0 365 0 550]);



%% Creating load profile vectors to plot

runcase=Lcase5;             % change runcase to define which load profile case to plot
timevector = 0;
plotvector = 0;
waterprod = 0;
j=1;


for i =1:24                          % Plotting load profile
    timevector(1) = 0;
    plotvector(1) = runcase(1);
    if runcase == Lcase1
        if mod(i,24) >= 9 && mod(i,24) <= 17
            waterprod (i) = 29.5;   % m3/h
        else 
            waterprod(i) = 0;   % m3/h
        end
    elseif runcase == Lcase2
            if mod(i,24) >= 9 && mod(i,24) <= 17
                waterprod(i) = 17.9;   % m3/h
            else
                waterprod(i) = 8.95;    % m3/h
            end
    elseif runcase == Lcase3
            waterprod(i) = 12.3;  % m3/h
    elseif runcase == Lcase4
            if mod(i,24) >= 9 && mod(i,24) <= 17
                waterprod(i) = 21.08;   % m3/h
            else 
                waterprod(i) = 7.03;     % m3/h
            end
    elseif runcase == Lcase5
            if mod(i,24) >= 9 && mod(i,24) <= 10 || mod(i,24) >= 16 && mod(i,24) <= 17 ;
                waterprod(i) = 13.73;   % m3/h
                 elseif mod(i,24) >= 10 && mod(i,24) <= 15;
                     waterprod(i) = 27.46;   % m3/h
            else 
                waterprod(i) = 6.87;   % m3/h
            end
    elseif runcase == Lcase6
            if mod(i,24) >= 9 && mod(i,24) <= 10 || mod(i,24) >= 16 && mod(i,24) <= 17 ;
                waterprod(i) = 21.09;   % m3/h
                elseif mod(i,24) >= 10 && mod(i,24) <= 15;
                    waterprod(i) = 42.17;   % m3/h
            else
                waterprod(i) = 0;   % m3/h
            end
    end
end

for i = 1:24                            % Plotting load profiles
    if runcase(i) == runcase(i+1); 
        plotvector(i+j) = runcase(i);
        timevector(i+j) = i;
%         waterprod(i+j) = waterprod(i);
    else
        timevector(i+j)=i;
        timevector(i+1+j)=i;
        plotvector(i+j) = runcase(i);
        plotvector(i+1+j) = runcase(i+1);
%         waterprod(i+j) = waterprod(i);
%         waterprod(i+1+j) = waterprod(i+1);
        j=j+1;
    end  
end



%% Plotting load profiles
                            
figure(2)
plot(timevector,plotvector,'k','LineWidth',2);
grid on
hold on
axis([0 24 0 70])
set(gca,'XTick',[0:2:24],'FontSize',12,'fontname','times');
xlabel('Hours of the day');
ylabel('Load (kW)');



%% Finding average energy deficit and battery storage sizes

Averagedeficit_case1 = mean(daydeficit1);
batt_case1 = mean(daydeficit1)/0.7;

Averagedeficit_case2 = mean(daydeficit2);
batt_case2 = Averagedeficit_case2/0.7;

Averagedeficit_case3 = mean(daydeficit3);
batt_case3 = Averagedeficit_case3/0.7;

Averagedeficit_case4 = mean(daydeficit4);
batt_case4 = Averagedeficit_case4/0.7;

Averagedeficit_case5 = mean(daydeficit5);
batt_case5 = Averagedeficit_case5/0.7;

Averagedeficit_case6 = mean(daydeficit6);
batt_case6 = Averagedeficit_case6/0.7;

avsurplus_case1 = mean(daysurplus1);
avsurplus_case2 = mean(daysurplus2);
avsurplus_case3 = mean(daysurplus3);
avsurplus_case4 = mean(daysurplus4);
avsurplus_case5 = mean(daysurplus5);
avsurplus_case6 = mean(daysurplus6);



%% Battery state of charge

SOCreal = 0;    % state of charge in percent regardless of max discharge
SOC = 0;        % state of charge in percent, min 30 %
level = 0;  % number of kWh in battery bank at the end of the day
dieselgen = 0;   % energy supplied from diesel generator in kWh
level1 = 0;level2 = 0;level3 = 0;level4 = 0;level5 = 0;level6 = 0;
SOCreal1 = 0; SOCreal2 = 0; SOCreal3 = 0; SOCreal4 = 0; SOCreal5 = 0; SOCreal6 = 0;
SOC1 = 0; SOC2 = 0; SOC3 = 0; SOC4 = 0; SOC5 = 0; SOC6 = 0;
dieselgen1 = 0; dieselgen2 = 0;dieselgen3 = 0;dieselgen4 = 0;dieselgen5 = 0;dieselgen6 = 0;

for i = 1: 365
    level1 (i) = batt_case1 - daydeficit1(i);  level2 (i) = batt_case2 - daydeficit2(i);  level3 (i) = batt_case3 - daydeficit3(i);  level4 (i) = batt_case4 - daydeficit4(i); level5 (i) = batt_case5 - daydeficit5(i);  level6 (i) = batt_case6 - daydeficit6(i);  
    SOCreal1(i) = (level1(i)/batt_case1)*100; SOCreal2(i) = (level2(i)/batt_case2)*100; SOCreal3(i) = (level3(i)/batt_case3)*100; SOCreal4(i) = (level4(i)/batt_case4)*100; SOCreal5(i) = (level5(i)/batt_case5)*100; SOCreal6(i) = (level6(i)/batt_case6)*100;
    if level1(i) >= 0                % Case 1
        if SOCreal1(i) >= 30
            SOC1(i) = SOCreal1(i);
            dieselgen1(i) = 0;

        else 
        SOC1(i) = 30;
        dieselgen1(i) = level1(i);
        end
    else
        SOC1(i) = 30;
        dieselgen1(i) = -level1(i);
    end
    
    if level2(i) >= 0                % Case 2
        if SOCreal2(i) >= 30
            SOC2(i) = SOCreal2(i);
            dieselgen2(i) = 0;

        else 
        SOC2(i) = 30;
        dieselgen2(i) = level2(i);
        end
    else
        SOC2(i) = 30;
        dieselgen2(i) = -level2(i);
    end
    
    if level3(i) >= 0                % Case 3
        if SOCreal3(i) >= 30
            SOC3(i) = SOCreal3(i);
            dieselgen3(i) = 0;

        else 
        SOC3(i) = 30;
        dieselgen3(i) = level3(i);
        end
    else
        SOC3(i) = 30;
        dieselgen3(i) = -level3(i);
    end
    
    if level4(i) >= 0                % Case 4
        if SOCreal4(i) >= 30
            SOC4(i) = SOCreal4(i);
            dieselgen4(i) = 0;
        else 
        SOC4(i) = 30;
        dieselgen4(i) = level4(i);
        end
    else
        SOC4(i) = 30;
        dieselgen4(i) = -level4(i);
    end
    
    if level5(i) >= 0                % Case 5
        if SOCreal5(i) >= 30
            SOC5(i) = SOCreal5(i);
            dieselgen5(i) = 0;
        else 
        SOC5(i) = 30;
        dieselgen5(i) = level5(i);
        end
    else
        SOC5(i) = 30;
        dieselgen5(i) = -level5(i);
    end
    
    if level6(i) >= 0                % Case 6
        if SOCreal6(i) >= 30
            SOC6(i) = SOCreal6(i);
            dieselgen6(i) = 0;
        else 
        SOC6(i) = 30;
        dieselgen6(i) = level6(i);
        end
    else
        SOC6(i) = 30;
        dieselgen6(i) = -level6(i);
    end
end
    

days = 1:1:365;


figure(10)
plot(SOC1,'LineWidth',1.2);hold on;plot(SOC2,'r','LineWidth',1.2);hold on;plot(SOC3,'g','LineWidth',1.2);hold on;plot(SOC4,'c','LineWidth',1.2);hold on;plot (SOC5,'k','LineWidth',1.2);hold on;plot(SOC6,'m','LineWidth',1.2);hold on;
title('State of charge all cases');
xlabel('Days');
ylabel('State of charge (%)');
legend('Case 1','Case2','Case 3','Case 4', 'Case 5', 'Case 6');
axis([0 365 30 100]);


%% Finding battery cycles

nocycles1 = 0;nocycles2 = 0; nocycles3 = 0; nocycles4 = 0; nocycles5 = 0; nocycles6 = 0;   % number of cycles per year

for i = 1:365
    nocycles1 = nocycles1 + 1-((SOC1(i)-30)/100);
    nocycles2 = nocycles2 + 1-((SOC2(i)-30)/100);
    nocycles3 = nocycles3 + 1-((SOC3(i)-30)/100);
    nocycles4 = nocycles4 + 1-((SOC4(i)-30)/100);
    nocycles5 = nocycles5 + 1-((SOC5(i)-30)/100);
    nocycles6 = nocycles6 + 1-((SOC6(i)-30)/100);
end

% nocycles1
% nocycles5
lifetime1 = round(0.7*1500/nocycles1);   % lifetime in year, multiplied by 0.7 due to degradation caused by heat. 1500 cycles at 100 % DOC from prosjektoppgave figure of battery lifetime
lifetime2 = round(0.7*1500/nocycles2);                        
lifetime3 = round(0.7*1500/nocycles3);                        
lifetime4 = round(0.7*1500/nocycles4);  
lifetime5 = round(0.7*1500/nocycles5);
lifetime6 = round(0.7*1500/nocycles6);


%% System costs and cash flows

membranes = [29 18 12 21 27 41];
batterysize = [batt_case1 batt_case2 batt_case3 batt_case4 batt_case5 batt_case6];
costmembrane = 1005;  % cost per piece
costbattery = 150;    % cost per kWh
% costbattery = input('Enter battery cost per kWh: ');
systemcost = 0;       % creating total cost vector
membranecost = 0;     % creating membrane cost vector
batterycost = 0;      % creating battery cost vector

for i = 1:length(membranes)                 % Adding values to total system cost vector
    systemcost(i) = membranes(i)*costmembrane + batterysize(i)*costbattery;
    membranecost(i) = membranes(i)*costmembrane;
    batterycost(i) = batterysize(i)*costbattery;
end

lifetime = 25;    % Lifetime in years
cashflowmemb1 = 0;cashflowmemb2 = 0;cashflowmemb3 = 0;cashflowmemb4 = 0;cashflowmemb5 = 0;cashflowmemb6 = 0;

cashflowbatteries = 0;                      % Assigning value in year 0

volumeperyear = 265.7*365;   % in m3
volumeperlifetime = volumeperyear/membranes(3);    % max volume in m3/membrane for whole lifetime
% factor1 = 1+(15/24);   % everything off for 15 hours at night
% factor2 = 1 ; % half of the plant off at nighttime
% factor4 = 1 + (7/15) ;  % 1/3 of the plant off at nighttime
memblifetime1 = volumeperlifetime/(volumeperyear/membranes(1));
memblifetime2 = volumeperlifetime/(volumeperyear/membranes(2));
memblifetime3 = 1;
memblifetime4 = volumeperlifetime/(volumeperyear/membranes(4));
memblifetime5 = volumeperlifetime/(volumeperyear/membranes(5));
memblifetime6 = volumeperlifetime/(volumeperyear/membranes(6));

daynr1 = floor(memblifetime1*365);    % Lifetime in day number
daynr2 = floor(memblifetime2*365);
daynr3 = floor(memblifetime3*365);
daynr4 = floor(memblifetime4*365);
daynr5 = floor(memblifetime5*365);
daynr6 = floor(memblifetime6*365);

days = zeros(26,6);

days(2,1)=daynr1; days(2,2)=daynr2; days(2,3)=daynr3; days(2,4)=daynr4; days(2,5)=daynr5; days(2,6)=daynr6;
daysin25 = 25*365;   % days in 25 years
c1=2;c2=2;c3=2;c4=2;c5=2;c6=2;     % to count number of dates for each case, starts by 2 since 2 variables are assigned already

for i = 3:26                        % insering day numbers into cell array
    if days(2,1)*(i-1) <= daysin25    
    days(i,1) = days(i-1,1)+daynr1;
    c1 = c1 + 1;
    else
        days(i,1) = 0;    
    end
    if days(2,2)*(i-1) <= daysin25
    days(i,2) = days(i-1,2)+daynr2;
    c2 = c2 + 1;
    else
        days(i,2) = 0;
    end
    if days(2,3)*(i-1) <= daysin25
    days(i,3) = days(i-1,3)+daynr3;
    c3 = c3 + 1;
    else
        days(i,3) = 0;
    end
    if days(2,4)*(i-1) <= daysin25
    days(i,4) = days(i-1,4)+daynr4;
    c4 = c4 + 1;
    else
        days(i,4) = 0;
    end
    if days(2,5)*(i-1) <= daysin25
    days(i,5) = days(i-1,5)+daynr5;
    c5 = c5 + 1;
    else
        days(i,5) = 0;
    end
    if days(2,6)*(i-1) <= daysin25
    days(i,6) = days(i-1,6)+daynr6;
    c6 = c6 + 1;
    else
        days(i,6) = 0;
    end
end



datestring = datestr(days,'mm/dd/yy',2000);    % returnerer en kolonne med alle datoene
cstring = cellstr(datestring);
dates1='';dates2 = ''; dates3 = ''; dates4 = ''; dates5 = ''; dates6 = '';   % vectors with all dates for each case

stringdates1 = cellstr(dates1);     % create cells of strings
stringdates2 = cellstr(dates2);
stringdates3 = cellstr(dates3);
stringdates4 = cellstr(dates4);
stringdates5 = cellstr(dates5);
stringdates6 = cellstr(dates6);

for i = 1:c1
    stringdates1(i) = cstring(i);
    cashflowmemb1(i) = membranecost(1);
end
for i = 1:c2
    stringdates2(i) = cstring(26+i);
    cashflowmemb2(i) = membranecost(2);
end
for i = 1:c3
    stringdates3(i) = cstring(52+i);
    cashflowmemb3(i) = membranecost(3);
end
for i = 1:c4
    stringdates4(i) = cstring(78+i);
    cashflowmemb4(i) = membranecost(4);
end
for i = 1:c5
    stringdates5(i) = cstring(104+i);
    cashflowmemb5(i) = membranecost(5);
end
for i = 1:c6
    stringdates6(i) = cstring(130+i);
    cashflowmemb6(i) = membranecost(6);
end



pvmemb1 = pvvar(cashflowmemb1,0.06,stringdates1);
pvmemb2 = pvvar(cashflowmemb2,0.06,stringdates2);
pvmemb3 = pvvar(cashflowmemb3,0.06,stringdates3);
pvmemb4 = pvvar(cashflowmemb4,0.06,stringdates4);
pvmemb5 = pvvar(cashflowmemb5,0.06,stringdates5);
pvmemb6 = pvvar(cashflowmemb6,0.06,stringdates6);


cashflowbatteries_c1(1) = batterycost(1);   % Inserting element 1 in cashflowmembranes (investment cost in year 0)
cashflowbatteries_c2(1) = batterycost(2);
cashflowbatteries_c3(1) = batterycost(3);
cashflowbatteries_c4(1) = batterycost(4);
cashflowbatteries_c5(1) = batterycost(5);
cashflowbatteries_c6(1) = batterycost(6);

count = 1;
count2 = 0;
for i = 2:lifetime+1                            % cashflow batteries Case 1
    if mod(i,(lifetime1+1)*count-count2) == 0
        cashflowbatteries_c1(i) = batterycost(1);
        count = count + 1;
        count2 = count2 + 1;
    else
        cashflowbatteries_c1(i) = 0;
    end
end
 cashflowbatteries_c1(lifetime+1) = cashflowbatteries_c1(lifetime+1) - ((batterycost(1)/4)*3);   % salvage value case 1



count = 1;
count2 = 0;
for i = 2:lifetime+1                            % cashflow batteries Case 2, 3, 4 and 5
    if mod(i,(lifetime2+1)*count - count2) == 0
        cashflowbatteries_c2(i) = batterycost(2);
        cashflowbatteries_c3(i) = batterycost(3);
        cashflowbatteries_c4(i) = batterycost(4);
        cashflowbatteries_c5(i) = batterycost(5);
        count = count + 1;
        count2 = count2 + 1;
    else
        cashflowbatteries_c2(i) = 0;
        cashflowbatteries_c3(i) = 0;
        cashflowbatteries_c4(i) = 0;
        cashflowbatteries_c5(i) = 0;
    end
end

cashflowbatteries_c2(lifetime+1) = cashflowbatteries_c2(lifetime+1) - ((batterycost(2)/3)*2);   % salvage value case 2
cashflowbatteries_c3(lifetime+1) = cashflowbatteries_c3(lifetime+1) - ((batterycost(3)/3)*2);   % salvage value case 3
cashflowbatteries_c4(lifetime+1) = cashflowbatteries_c4(lifetime+1) - ((batterycost(4)/3)*2);   % salvage value case 4
cashflowbatteries_c5(lifetime+1) = cashflowbatteries_c5(lifetime+1) - ((batterycost(5)/3)*2);   % salvage value case 5

count = 1;
count2 = 0;
for i = 2:lifetime +1                   % cashflow batteries Case 6
    if mod(i,(lifetime6+1)*count - count2) == 0
        cashflowbatteries_c6(i) = batterycost(6);
        count = count + 1;
        count2 = count2 + 1;
    else
        cashflowbatteries_c6(i) = 0;
    end
end

cashflowbatteries_c6(lifetime+1) = cashflowbatteries_c6(lifetime+1) - ((batterycost(6)/5)*4);   % salvage value case 6


pvbatt1 = pvvar(cashflowbatteries_c1,0.06);
pvbatt2 = pvvar(cashflowbatteries_c2,0.06);
pvbatt3 = pvvar(cashflowbatteries_c3,0.06);
pvbatt4 = pvvar(cashflowbatteries_c4,0.06);
pvbatt5 = pvvar(cashflowbatteries_c5,0.06);
pvbatt6 = pvvar(cashflowbatteries_c6,0.06);
   
NPC1 = pvmemb1 + pvbatt1;   % computing net present value of each case
NPC2 = pvmemb2 + pvbatt2;
NPC3 = pvmemb3 + pvbatt3;
NPC4 = pvmemb4 + pvbatt4;
NPC5 = pvmemb5 + pvbatt5;
NPC6 = pvmemb6 + pvbatt6;


NPC_allcases = [NPC1 NPC2 NPC3 NPC4 NPC5 NPC6];

casenumbers = [1 2 3 4 5 6];


NPCmemb = [pvmemb1 pvmemb2 pvmemb3 pvmemb4 pvmemb5 pvmemb6];
NPCmemb1000 = NPCmemb/1000;     % vector with NPC in 1000 dollars
figure(12)                                                 % Plotting NPC all cases for membranes only
bar(casenumbers, NPCmemb1000,0.5,'k');hold on;
box off
axis([0.5 6.5 140 190]);
set(gca,'FontSize',12,'fontname','times');
set(gca,'XTick',1:1:6);
xlabel('Scenario number');
ylabel('NPC of membranes (1000 $)');
grid on


NPCbatt = [pvbatt1 pvbatt2 pvbatt3 pvbatt4 pvbatt5 pvbatt6];
NPCbatt1000 = NPCbatt/1000;   % vector with NPC in 1000 $
figure(13)                                                    % Plotting NPC all cases for batteries only
bar(casenumbers,NPCbatt1000,0.5,'k');hold on;
box off
axis([0.5 6.5 0 350]);
set(gca,'FontSize',12,'fontname','times');
set(gca,'XTick',1:1:6);
xlabel('Scenario number');
ylabel('NPC of batteries (1000 $)');
grid on

NPC_allcases1000 = NPC_allcases/1000;
figure(6)                                                  % Plotting NPC all cases for membranes and batteries
bar(casenumbers, NPC_allcases1000,0.5,'k');hold on;
box off
axis([0.5 6.5 150 550]);
set(gca,'XTick',0:1:6);
xlabel('Case number');
ylabel('Net present cost of membranes and batteries (1000 $)');
grid on;


memblifetime = [memblifetime1 memblifetime2 memblifetime3 memblifetime4 memblifetime5 memblifetime6];   % plotting membrane lifetime
figure(14)
subplot(2,1,1)
scatter(casenumbers,memblifetime,'fill','k');hold on;
plot(casenumbers,memblifetime,'k-');hold on;
set(gca,'FontSize',12,'fontname','times');
axis([0.5 6.5 0 3.5]);
set(gca,'XTick',1:1:6);
xlabel('Scenario number');
ylabel('Lifetime of membranes (years)');
grid on
subplot(2,1,2)
scatter(casenumbers,membranes,'fill','k');hold on;
plot(casenumbers,membranes,'k-');hold on;
set(gca,'FontSize',12,'fontname','times');
axis([0.5 6.5 0 44]);
set(gca,'XTick',1:1:6);
set(gca,'YTick',0:10:40);
xlabel('Scenario number');
ylabel('Number of membranes');
grid on


battlifetime = [lifetime1 lifetime2 lifetime3 lifetime4 lifetime5 lifetime6];   % plotting battery lifetime
figure(15)
subplot(2,1,1)
scatter(casenumbers,battlifetime,'fill','k');hold on;
plot(casenumbers,battlifetime,'k-');hold on;
set(gca,'FontSize',12,'fontname','times');
axis([0.5 6.5 0 10]);
set(gca,'XTick',0:1:6);
set(gca,'YTick',0:2:12);
xlabel('Scenario number');
ylabel('Lifetime of batteries (years)');
grid on
subplot(2,1,2)
scatter(casenumbers,batterysize,'fill','k');hold on;
plot(casenumbers,batterysize,'k');hold on;
set(gca,'FontSize',12,'fontname','times');
axis([0.6 6.5 0 500]);
set(gca,'XTick',0:1:6);
set(gca,'YTick',0:100:500);
xlabel('Scenario number');
ylabel('Battery size (kWh)');
grid on


%% Plotting membranes vs battery size

figure(16)                                   % Figure of battery size vs membranes

scatter(membranes,batterysize,'fill','k');hold on;
grid on
set(gca,'FontSize',12,'fontname','times');
labels ={'Scenario 1','Scenario 2','Scenario 3','Scenario 4','Scenario 5','Scenario 6'};
dx=0.5;
dy=0.5;
text(membranes+dx,batterysize+dy,labels);
axis([0 50 0 500]);
set(gca,'YTick',0:100:500);
set(gca,'XTick',0:5:50);
xlabel('Number of membranes');
ylabel('Battery size (kWh)');


